;=======558SINE.ASM==================================6/3/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
pc	equ	0x02
status	equ	0x03
porta	equ	0x05
portb   equ     0x06
count1	equ	0x0c
offctr	equ	0x0d
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
c	equ	0
z	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start	goto	do_it	;jump over table
;------------------------------------------------------------
table	addwf	pc,f	;add offset to program counter
	retlw	0x80	;1.28 volts
	retlw	0x95	;1.50
	retlw	0xad	;1.72
	retlw	0xc1	;1.92
	retlw	0xd3	;2.10
	retlw	0xe2	;2.26
	retlw	0xef	;2.39
	retlw	0xf8	;2.48
	retlw	0xfd	;2.54
	retlw	0xff	;2.55
	retlw	0xfd	;2.54
	retlw	0xf8	;2.48
	retlw	0xef	;2.39
	retlw	0xe2	;2.26
	retlw	0xd3	;2.10
	retlw	0xc1	;1.92
	retlw	0xad	;1.72
	retlw	0x95	;1.50
	retlw	0x80	;1.28
	retlw	0x6a	;1.06
	retlw	0x54	;0.84
	retlw	0x40	;0.64
	retlw	0x2e	;0.46
	retlw	0x1e	;0.30
	retlw	0x11	;0.17
	retlw	0x08	;0.08
	retlw	0x02	;0.02
	retlw	0x00	;0.00
	retlw	0x02	;0.02
	retlw	0x08	;0.08
	retlw	0x11	;0.17
	retlw	0x1e	;0.30
	retlw	0x2e	;0.46
	retlw	0x40	;0.64
	retlw	0x54	;0.84
	retlw	0x6a	;1.06
;------------------------------------------------------------
do_it	bsf     status,rp0  ;switch to bank 1
	movlw	b'00000000' ;outputs
        movwf   trisa
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	movlw	0x00	;00000000
	movwf	porta	;initialize, cs low
cycle	clrf	offctr	;clear table offset counter
step	movf	offctr,w    ;get offset count
	call	table	;get volts from table
	movwf	portb	;output data to D/A	
	bsf	porta,0	;pulse D/A to latch data
	bcf	porta,0
	call	delay	;delay
	movf	offctr,w    ;get offset count
	sublw	0x23	;compare - cycle complete?
	btfsc	status,z
	goto	cycle
	incf	offctr	;increment offset counter
	goto	step
;------------------------------------------------------------
delay	movlw	0x01	;3N+3 cycles (decimal), N=1 shown
	movwf	count1	;load counter
repeat	decfsz	count1,f   ;decrement counter
	goto	repeat	;not 0
	return		;counter 0, ends delay
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================


 



