;=======AD16C71.ASM=================================6/12/97==
        list    p=16c71
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
porta	equ	0x05
portb   equ     0x06
status	equ	0x03
adcon0	equ	0x08
adres	equ	0x09
intcon	equ	0x0b
count	equ	0x0d
ncount	equ	0x10
mcount	equ	0x11
trisa	equ	0x85
trisb	equ	0x86
adcon1	equ	0x88
;------------------------------------------------------------
;	bit equates
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000011' ;inputs/outputs
        movwf   trisa
	movlw	b'00000000' ;outputs
	movwf	trisb
	movlw	b'00000010' ;port A, bits 1,0 analog input
	movwf	adcon1	    ;   bits 3,2 digital I/O
	bcf	status,rp0  ;switch back to bank 0
	clrf	portb	;LEDs off
	bcf	intcon,7    ;global interrupt disable
meas	movlw	b'10000001' ;configure A/D - select AN0
	movwf	adcon0	    ;   select conv clock, AN0 on
	call	del_20	;delay 20 microseconds
	bsf	adcon0,2    ;start conversion
test	btfsc	adcon0,2    ;test go/done bit
	goto	test
	movf	adres,w	    ;conv complete, get A/D result
	movwf	portb	;display data via LEDS
	call    debounce   ;wait a while (200 milliseconds)
	goto	meas	;look at voltage again
;------------------------------------------------------------
del_20	movlw	0x07	;delay 20 microseconds
	movwf	count
repeat	decfsz	count
	goto	repeat
	return
;------------------------------------------------------------  
debounce ;movlw  ;0xff	;M
	movwf	mcount	;to M counter
loadn	movlw	0xff	;N
	movwf	ncount	;to N counter
decn	decfsz	ncount,f  ;decrement N
	goto	decn	;again
	decfsz	mcount,f  ;decrement M
	goto	loadn	;again
	return		;done
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================

