;=======DBLB2DY.ASM==========================6/27/97==
;accepts 0x0000 through ffff - 0 through 65535
;dblsub uses 2's comp plus flag
;-----------------------------------------------------
        list    p=16c84
        radix   hex
;-----------------------------------------------------
;       cpu equates (memory map)
indf	equ	0x00
pc	equ	0x02
status  equ     0x03
fsr	equ	0x04
ms      equ     0x0c
ls	equ	0x0d
index	equ	0x0e
dig_ctr	equ	0x0f
lsb1	equ	0x10
msb1	equ	0x11
lsb2	equ	0x12
msb2	equ	0x13
flags	equ	0x14
tenk	equ	0x20
onek	equ	0x21
hund	equ	0x22
ten	equ	0x23
one	equ	0x24	
;-----------------------------------------------------
;	bit equates
c	equ	0
ovflw	equ	0
z	equ	2
rp0	equ	5
;-----------------------------------------------------
        org     0x000
;
start   movlw   0xfa	;define test number MS byte
	movwf	ms
	movlw	0x00	;define test number LS byte
	movwf	ls
;prep for calling conversion subroutine
	movf	ms,w	;get MS byte
	movwf	msb2
	movf	ls,w	;get LS byte
	movwf	lsb2
	call	dblb2d	;call conversion subroutine
circle  goto    circle  ;done
;-----------------------------------------------------
tbl_lo	addwf	pc,f	;add index to program counter
	retlw	0x10	;10,000 decimal
	retlw	0xe8	;1,000 decimal	
	retlw	0x64	;100 decimal
	retlw	0x0a	;10 decimal	
;-----------------------------------------------------
tbl_hi	addwf	pc,f	;add index to program counter
        retlw	0x27	;10,000 decimal
	retlw	0x03	;1,000 decimal	
	retlw	0x00	;100 decimal
	retlw	0x00	;10 decimal
;-----------------------------------------------------
dblb2d	clrf	tenk
	clrf	onek
	clrf	hund
	clrf	ten
	clrf	one
	clrf	index
	clrf	dig_ctr
	bcf	flags,ovflw
subtr	movf	index,w	;get current index into W
	call	tbl_lo	;get ls chunk for subtraction	
	movwf	lsb1
	movf	index,w	;get current index into W
	call	tbl_hi	;get ms chunk for subtraction
	movwf	msb1
	call	dblsub  ;to double precision subtraction
	btfsc	status,c  ;test carry flag
	goto	incdig
	movlw	0x20	;load base address of table
	movwf	fsr
	movf	index,w	;get index
	addwf	fsr,f	;add offset
	movf	dig_ctr,w  ;get digit counter contents
	movwf	indf	;store at digit loc (indexed)
	movf	index,w	;get index
	call	tbl_lo	;get ls chunk for addition
	movwf	lsb1
	movf	index,w	;get index
	call	tbl_hi	;get ms chunk for addition
	movwf	msb1
	bcf	flags,ovflw	
	call	dblplus ;to double precision addition
	movf	index,w	;get index
	sublw	0x03	;index=3?
	btfsc	status,z
	goto	finish
	incf	index,f	;increment digit index
	clrf	dig_ctr
	goto	subtr
;-----------------------------------------------------
incdig	incf	dig_ctr,f ;increment digit counter
	goto	subtr
;-----------------------------------------------------
finish	movf	lsb2,w  ;get 1's=remainder
	movwf	one
	return		;done
;-----------------------------------------------------
dblsub	bcf	flags,ovflw ;clear overflow flag
	comf	lsb1,f	;2's complement stuff
	comf	msb1,f
	movf	lsb1,w
	addlw	0x01
	movwf	lsb1
	btfsc	status,c
	incf	msb1,f
dblplus	movf	lsb1,w
	addwf	lsb2,f	;add low bytes
	btfsc	status,c
	bsf	flags,ovflw ;indicate overflow occured
	movf	msb1,w
	addwf	msb2,f	;add high bytes
	btfss	flags,ovflw
	goto	dblx
	btfsc	status,c
	goto	dbl1
	movlw	0x01
	addwf	msb2,f
	goto	dblx
dbl1	incf	msb2,f
dblx	return
;-----------------------------------------------------
        end
;-----------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test)
;       power-up timer on
;=====================================================






