;=======DBLB2DZ.ASM==========================6/25/97==
;accepts 0x0000 through 7fff - 0 through 32767
;-----------------------------------------------------
        list    p=16c84
        radix   hex
;-----------------------------------------------------
;       cpu equates (memory map)
indf	equ	0x00
pc	equ	0x02
status  equ     0x03
fsr	equ	0x04
ms      equ     0x0c
ls	equ	0x0d
index	equ	0x0e
dig_ctr	equ	0x0f
lsb1	equ	0x10
msb1	equ	0x11
lsb2	equ	0x12
msb2	equ	0x13
tenk	equ	0x20
onek	equ	0x21
hund	equ	0x22
ten	equ	0x23
one	equ	0x24	
;-----------------------------------------------------
;	bit equates
c	equ	0
z	equ	2
rp0	equ	5
;-----------------------------------------------------
        org     0x000
;
start   movlw   0x7f ;define test number MS byte
	movwf	ms
	movlw	0xff;define test number LS byte
	movwf	ls
;prep for calling conversion subroutine
	movf	ms,w	;get MS byte
	movwf	msb2
	movf	ls,w	;get LS byte
	movwf	lsb2
	call	dblb2d	;call conversion subroutine
circle  goto    circle  ;done
;-----------------------------------------------------
tbl_lo	addwf	pc,f	;add index to program counter
	retlw	0x10	;10,000 decimal
	retlw	0xe8	;1,000 decimal	
	retlw	0x64	;100 decimal
	retlw	0x0a	;10 decimal	
;-----------------------------------------------------
tbl_hi	addwf	pc,f	;add index to program counter
        retlw	0x27	;10,000 decimal
	retlw	0x03	;1,000 decimal	
	retlw	0x00	;100 decimal
	retlw	0x00	;10 decimal
;-----------------------------------------------------
dblb2d	clrf	tenk
	clrf	onek
	clrf	hund
	clrf	ten
	clrf	one
	clrf	index
	clrf	dig_ctr
subtr	movf	index,w	;get current index into W
	call	tbl_lo	;get ls chunk for subtraction	
	movwf	lsb1
	movf	index,w	;get current index into W
	call	tbl_hi	;get ms chunk for subtraction
	movwf	msb1
	call	dblsub  ;to double precision subtraction
	btfss	msb2,7  ;test bit 7, 1 means neg result
	goto	incdig
	movlw	0x20	;load base address of table
	movwf	fsr
	movf	index,w	;get index
	addwf	fsr,f	;add offset
	movf	dig_ctr,w  ;get digit counter contents
	movwf	indf	;store at digit loc (indexed)
	movf	index,w	;get index
	call	tbl_lo	;get ls chunk for addition
	movwf	lsb1
	movf	index,w	;get index
	call	tbl_hi	;get ms chunk for addition
	movwf	msb1	
	call	dblplus ;to double precision addition
	movf	index,w	;get index
	sublw	0x03	;index=3?
	btfsc	status,z
	goto	finish
	incf	index,f	;increment digit index
	clrf	dig_ctr
	goto	subtr
;-----------------------------------------------------
incdig	incf	dig_ctr,f ;increment digit counter
	goto	subtr
;-----------------------------------------------------
finish	movf	lsb2,w  ;get 1's=remainder
	movwf	one
	return		;done
;-----------------------------------------------------
dblsub	movf	lsb1,w  ;fetch lsb1
	subwf	lsb2,f	;subt low bytes, result in lsb2
	btfss	status,c   ;carry clear?
	decf	msb2,f	;yes, subtract 1 from msb2
	movf	msb1,w	;fetch msb1
	subwf	msb2,f	;sub high bytes, result in msb2
	return
;-----------------------------------------------------
dblplus movf	lsb1,w  ;fetch lsb1
	addwf	lsb2,f	;add low bytes, result in lsb2
	btfsc	status,c   ;carry set?
	incf	msb2,f	;yes, add 1 to msb result
	movf	msb1,w	;fetch msb1
	addwf	msb2,f	;add high bytes, result in msb2
	return
;-----------------------------------------------------
        end
;-----------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test)
;       power-up timer on
;=====================================================









