;=======DISPLHEX.ASM=================================5/9/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
indf	equ	0x00
pc	equ	0x02
status  equ     0x03
fsr	equ	0x04
hexbyte	equ	0x0c
ms_dig	equ	0x0d
ls_dig	equ	0x0e
hold	equ	0x0f
sa	equ	0x10
sb	equ	0x11
sc	equ	0x12
sd	equ	0x13
count1	equ	0x14
;------------------------------------------------------------
;	bit equates
c	equ	0
;------------------------------------------------------------
;note: this works in MPSIM, not in chip
        org     0x000
;
start   movlw   0x01   ;load w with 0x__, test byte
	call	disphex	;call display hex byte sub
;			   returns with display RAM filled
circle	goto	circle	;done
;------------------------------------------------------------
table	addwf	pc,f	;add offset to program counter
	retlw	0x00	;0
	retlw	0x01	;1
	retlw	0x04	;2
	retlw	0x07	;3
	retlw	0x0b	;4	
	retlw	0x0e	;5
	retlw	0x12	;6
	retlw	0x16	;7
	retlw	0x1a	;8
	retlw	0x1d	;9
	retlw	0x21	;a
	retlw	0x25	;b
	retlw	0x29	;c
	retlw	0x2d	;d
	retlw	0x31	;e
	retlw	0x35	;f
;------------------------------------------------------------
makbits	addwf	pc,f	;add offset to program counter
	return		;0x0	0000   leave as is
	movlw	0x31	;0x1	0001
	movwf	sd
	return
	movlw	0x31	;0x2	0010
	movwf	sc
	return
	movlw	0x31	;0x3	0011
	movwf	sc
	movwf	sd
	return
	movlw	0x31	;0x4	0100
	movwf	sb
	return
	movlw	0x31	;0x5	0101
	movwf	sb
	movwf	sd
	return
	movlw	0x31	;0x6	0110
	movwf	sb
	movwf	sc
	return
	call	fill1s	;0x7	0111   fill with 1,s
	movlw	0x30
	movwf	sa
	return
	movlw	0x31	;0x8	1000
	movwf	sa
	return
	movlw	0x31	;0x9	1001
	movwf	sa
	movwf	sd
	return
	movlw	0x31	;0xa	1010
	movwf	sa
	movwf	sc
	return
	call	fill1s	;0xb	1011   fill with 1,s
	movlw	0x30
	movwf	sb
	return
	movlw	0x31	;0xc	1100
	movwf	sa
	movwf	sb
	return
	call	fill1s	;0xd	1101   fill with 1,s
	movlw	0x30
	movwf	sc
	return
	call	fill1s	;0xe	1110   fill with 1,s
	movlw	0x30
	movwf	sd
	return
	goto	fill1s	;0xf	1111   fill with 1,s
	return
;------------------------------------------------------------
fill1s	movlw	0x31
	movwf	sa
	movwf	sb
	movwf	sc
	movwf	sd
	return
;------------------------------------------------------------
disphex	movwf	hexbyte	;store copy of hex byte
	call	blanks	;fill display RAM with blanks
	call	sephex	;separate hex byte into 2 ASCII digits
	movf	ms_dig,w   ;get MS digit
	movwf	0x20	;to display RAM
	movf	ls_dig,w   ;get LS digit
	movwf	0x21	;to display RAM
	swapf	hexbyte,w  ;get copy of hex byte, swap MS/LS
	andlw	0x0f	;mask HI nybble
	call	hexbits	;call hex to bits
	movf	sa,w	;get first bit
	movwf	0x23	;to display RAM
	movf	sb,w	;get second bit
	movwf	0x24	;to display RAM
	movf	sc,w	;etc.
	movwf	0x25
	movf	sd,w
	movwf	0x26
	movf	hexbyte,w  ;get copy of hex byte
	andlw	0x0f	;mask HI nybble
	call	hexbits	;call hex to bits
	movf	sa,w	;get first bit
	movwf	0x28	;to display RAM
	movf	sb,w	;get second bit
	movwf	0x29	;to display RAM
	movf	sc,w	;etc.
	movwf	0x2a
	movf	sd,w
	movwf	0x2b
	return
;------------------------------------------------------------
sephex	movf	hexbyte,w   ;get copy of hex byte
	andlw	0x0f	;mask hi nybble
	call	hex2asc	;hex to ASCII conversion
	movwf	ls_dig	;store
	swapf	hexbyte,w   ;get copy of hex byte, swap MS/LS
	andlw	0x0f	;mask hi nybble
	call	hex2asc	;hex to ASCII conversion
	movwf	ms_dig	;store
	return
;------------------------------------------------------------
hex2asc	movwf	hold	;store copy of hex digit
	sublw	0x09	;subtract w from 1 less than 0x0a
	btfss	status,c   ;carry flag set if w < 0x0a
	goto	add37
	goto	add30
add37	movf	hold,w	;get hex digit
	addlw	0x37
	return		;return with ascii in w
add30	movf	hold,w	;get hex digit
	addlw	0x30
	return		;return with ascii in w
;------------------------------------------------------------
hexbits	movwf	hold	;save copy of hex digit
	movlw	0x30	;fill with ascii 0's
	movwf	sa
	movwf	sb
	movwf	sc
	movwf	sd
	movf	hold,w	;get hex digit, use as offset
	call	table	;get 2nd offset for subroutine table
	call	makbits	;to appropriate create bits sub
	return
;------------------------------------------------------------
blanks	movlw	0x10	;count=16
	movwf	count1
	movlw	0x20	;first display RAM address
	movwf	fsr	;indexed addressing
	movlw	0x20	;ascii blank
store	movwf	indf	;store in display RAM location
;			   pointed to by file select register
	decfsz	count1,f  ;16?
	goto	incfsr	;no
	return		;yes, done
incfsr	incf	fsr,f	;increment file select register
	goto	store
;------------------------------------------------------------
        end
;----------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test)
;       power-up timer on
;=====================================================
