;=======P2PRCV.ASM==================================4/29/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta   equ     0x05
portb	equ	0x06
intcon	equ	0x0b
rcvreg	equ	0x0c
count	equ	0x0d
temp	equ	0x0e
optreg	equ	0x81
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000101' ;port A inputs/outputs
        movwf   trisa
	movlw	b'00000000' ;port B outputs
	movwf	trisb
	bcf	status,rp0  ;back to bank 0
	clrf	portb
	clrf	rcvreg
switch	btfsc	porta,2	;operator ready to receive?
	goto	switch	;no
	call	ser_in	;yes, to serial in subroutine
	movf	rcvreg,w    ;get byte received
	movwf	portb	;display via LEDs
circle  goto    circle  ;done
;------------------------------------------------------------
ser_in	bcf	intcon,5   ;disable tmr0 interrupts
	bcf	intcon,7   ;disable global interrupts
	clrf	tmr0	;clear timer/counter
	clrwdt		;clear wdt prep prescaler assign
	bsf	status,rp0   ;to page 1
	movlw	b'11011000'  ;set up timer/counter
	movwf	optreg
	bcf	status,rp0   ;back to page 0
	movlw	0x08	;init shift counter
	movwf	count
sbit	btfsc	porta,0	;look for start bit
	goto	sbit	;mark
	movlw	0x80	;start bit received, half bit time
	movwf	tmr0	;load and start timer/counter
	bcf	intcon,2   ;clear tmr0 overflow flag
time1	btfss	intcon,2   ;timer overflow?
	goto	time1	;no
	btfsc	porta,0	;start bit still low?
	goto	sbit	;false start, go back
	clrf	tmr0	;yes, half bit time - start timer/ctr
	bcf	intcon,2   ;clear tmr0 overflow flag
time2	btfss	intcon,2   ;timer overflow?
	goto	time2	;no
	bcf	intcon,2   ;yes, clear tmr0 overflow flag
	movf	porta,w	;read port A
	movwf	temp	;store
	rrf	temp,f	;rotate bit 0 into carry flag
	rlf	rcvreg,f   ;rotate carry into rcvreg bit 0
	decfsz	count,f	;shifted 8?
	goto	time2	;no
time3	btfss	intcon,2   ;timer overflow?
	goto	time3	;no
	return		;yes, byte received
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================
