;=======P2PSEND.ASM=================================4/29/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta   equ     0x05
intcon	equ	0x0b
sendreg	equ	0x0c
count	equ	0x0d
optreg	equ	0x81
trisa	equ	0x85
;------------------------------------------------------------
;	bit equates
c	equ	0
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000100' ;port A inputs/outputs
        movwf   trisa
	bcf	status,rp0  ;switch back to bank 0
	bsf	porta,1	;output mark, bit 1
	movlw	0x80	;number to be sent
	movwf	sendreg	;store
switch	btfsc	porta,2	;start send?
	goto	switch	;not yet
	call	ser_out	;to serial out subroutine
circle  goto    circle  ;done
;------------------------------------------------------------
ser_out	bcf	intcon,5   ;disable tmr0 interrupts
	bcf	intcon,7   ;disable global interrupts
	clrf	tmr0	;clear timer/counter
	clrwdt		;clear wdt prep prescaler assign
	bsf	status,rp0   ;to page 1
	movlw	b'11011000'  ;set up timer/counter
	movwf	optreg
	bcf	status,rp0   ;back to page 0
	movlw	0x08	;init shift counter
	movwf	count	
	bcf	porta,1	;start bit
	clrf	tmr0	;start timer/counter
	bcf	intcon,2   ;clear tmr0 overflow flag
time1	btfss	intcon,2   ;timer overflow?
	goto	time1	;no
	bcf	intcon,2   ;yes, clear overflow flag
nxtbit	rlf	sendreg,f  ;rotate msb into carry flag
	bcf	porta,1	;clear port A, bit 1
	btfsc	status,c   ;test carry flag
	bsf	porta,1 ;bit is set
time2	btfss	intcon,2   ;timer overflow?
	goto	time2	;no
	bcf	intcon,2   ;clear overflow flag
	decfsz	count,f	;shifted 8?
	goto	nxtbit	;no
	bsf	porta,1	;yes, output mark
time3	btfss	intcon,2   ;timer overflow?
	goto	time3	;no
	return		;done
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================
