;=======RAMP.ASM=====================================6/3/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
status	equ	0x03
porta   equ     0x05
sendreg	equ	0x0c
count	equ	0x0d
control	equ	0x0e
volts	equ	0x0f
count1	equ	0x10
trisa	equ	0x85
;------------------------------------------------------------
;	bit equates
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000000' ;outputs
        movwf   trisa
	bcf	status,rp0  ;switch back to bank 0
	movlw	0x04	;0000 0100
	movwf	porta	;initialize port
	movlw	b'00110001' ;define control word
	movwf	control	;store - ready for sub
	movlw	b'00000000'  ;0 volts out to start
	movwf	volts	;store - ready for sub
loop	call	sub1
	call	del_10	;delay
	incf	volts	;increment voltage
	goto	loop
;------------------------------------------------------------
sub1	bcf	porta,2	;CS low - start serial comm process
	movf	control,w   ;get control word
	call	ser_out     ;to serial out subroutine
	movf	volts,w	;get data
	call	ser_out	;to serial out subroutine
	bsf	porta,2	;CS high - end serial comm process
	return
;------------------------------------------------------------
ser_out	movwf	sendreg	;save copy of byte
	movlw	0x08	;init 8 counter
	movwf	count
testbit	bcf	porta,0	;default
	btfsc	sendreg,7  ;test byte bit 7
	bsf	porta,0 ;bit is set
shift	bsf	porta,1	;shift register
	bcf	porta,1
rotlft	rlf	sendreg,f  ;shift byte left
	decfsz	count,f	;decrement bit counter
	goto	testbit	;next bit
	return		;done
;------------------------------------------------------------
del_10	movlw	0x03	;approx 9 cycles (decimal)
	movwf	count1	;load counter
repeat	decfsz	count1,f   ;decrement counter
	goto	repeat	;not 0
	return		;counter 0, ends delay
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================
