;=======SCANFCT.ASM=================================5/21/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta   equ     0x05
portb	equ	0x06
intcon	equ	0x0b
sendreg	equ	0x0c
count	equ	0x0d
instr	equ	0x0e
char	equ	0x0f
addr	equ	0x10
count1	equ	0x11
ncount	equ	0x12
mcount	equ	0x13
funct	equ	0x14
optreg	equ	0x81
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
c	equ	0
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0 ;switch to bank 1
	movlw	b'00000000' ;port A outputs
        movwf   trisa
	movlw	b'01110000' ;port B inputs/outputs
	movwf	trisb
	bcf	status,rp0 ;switch back to bank 0
	bsf	porta,1	;output mark, bit 1 (serial - LCD)
	bsf	portb,0	;rows high
	bsf	portb,1
	bsf	portb,2
	bsf	portb,3
	bcf	portb,7	;unused line low
ckpad	call	scanfct
	movlw	0x04	;hex byte follows
	movwf	instr
	movf	funct,w   ;get character
	movwf	char
	call	sndstf	;call send stuff
	call	debounce   ;time delay - debounce switches
	goto	ckpad	;repeat
;------------------------------------------------------------
scanfct	bsf	portb,0	;rows high
	bsf	portb,1
	bsf	portb,2
	bsf	portb,3
	clrf	funct
	bcf	portb,3	;row=4
testk	btfss	portb,4	;test column 1
	goto	star	;"*" key pressed
	btfss	portb,6	;test column 3
	goto	pound	;# key pressed
	goto	testk	;no key pressed
star	movlw	0xaa	;*
	movwf	funct
	return
pound	movlw	0x88	;#
	movwf	funct
	return
;------------------------------------------------------------  
debounce movlw  0xff	;M
	movwf	mcount	;to M counter
loadn	movlw	0xff	;N
	movwf	ncount	;to N counter
decn	decfsz	ncount,f   ;decrement N
	goto	decn	;again
	decfsz	mcount,f   ;decrement M
	goto	loadn	;again
	return		;done
;------------------------------------------------------------
sndstf	movf	instr,w	;get instruction
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	char,w	;get character or hex byte
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	addr,w	;get address
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	return
;------------------------------------------------------------
ser_out	bcf	intcon,5   ;disable tmr0 interrupts
	bcf	intcon,7   ;disable global interrupts
	clrf	tmr0	;clear timer/counter
	clrwdt		;clear wdt prep prescaler assign
	bsf	status,rp0   ;to page 1
	movlw	b'11011000'  ;set up timer/counter
	movwf	optreg
	bcf	status,rp0   ;back to page 0
	movlw	0x08	;init shift counter
	movwf	count	
	bcf	porta,1	;start bit
	clrf	tmr0	;start timer/counter
	bcf	intcon,2   ;clear tmr0 overflow flag
time1	btfss	intcon,2   ;timer overflow?
	goto	time1	;no
	bcf	intcon,2   ;yes, clear overflow flag
nxtbit	rlf	sendreg,f  ;rotate msb into carry flag
	bcf	porta,1	;clear port A, bit 1
	btfsc	status,c   ;test carry flag
	bsf	porta,1 ;bit is set 
time2	btfss	intcon,2   ;timer overflow?
	goto	time2	;no
	bcf	intcon,2   ;clear overflow flag
	decfsz	count,f	;shifted 8?
	goto	nxtbit	;no
	bsf	porta,1	;yes, output mark
time3	btfss	intcon,2   ;timer overflow?
	goto	time3	;no
	return		;done
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================







