;=======TESTHEX.ASM=================================5/14/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
indf	equ	0x00
pc	equ	0x02
status  equ     0x03
fsr	equ	0x04
porta	equ	0x05
portb   equ     0x06
hexbyte	equ	0x0c
ms_dig	equ	0x0d
ls_dig	equ	0x0e
hold	equ	0x0f
sa	equ	0x10
sb	equ	0x11
sc	equ	0x12
sd	equ	0x13
count1	equ	0x14
count2	equ	0x15
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
c	equ	0
z	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start	goto	main	;leap over tables
;------------------------------------------------------------
table	addwf	pc,f	;add offset to program counter
	retlw	0x00	;0
	retlw	0x01	;1
	retlw	0x04	;2
	retlw	0x07	;3
	retlw	0x0b	;4	
	retlw	0x0e	;5
	retlw	0x12	;6
	retlw	0x16	;7
	retlw	0x1a	;8
	retlw	0x1d	;9
	retlw	0x21	;a
	retlw	0x25	;b
	retlw	0x29	;c
	retlw	0x2d	;d
	retlw	0x31	;e
	retlw	0x35	;f
;------------------------------------------------------------
makbits	addwf	pc,f	;add offset to program counter
	return		;0x0	0000   leave as is
	movlw	0x31	;0x1	0001
	movwf	sd
	return
	movlw	0x31	;0x2	0010
	movwf	sc
	return
	movlw	0x31	;0x3	0011
	movwf	sc
	movwf	sd
	return
	movlw	0x31	;0x4	0100
	movwf	sb
	return
	movlw	0x31	;0x5	0101
	movwf	sb
	movwf	sd
	return
	movlw	0x31	;0x6	0110
	movwf	sb
	movwf	sc
	return
	call	fill1s	;0x7	0111   fill with 1,s
	movlw	0x30
	movwf	sa
	return
	movlw	0x31	;0x8	1000
	movwf	sa
	return
	movlw	0x31	;0x9	1001
	movwf	sa
	movwf	sd
	return
	movlw	0x31	;0xa	1010
	movwf	sa
	movwf	sc
	return
	call	fill1s	;0xb	1011   fill with 1,s
	movlw	0x30
	movwf	sb
	return
	movlw	0x31	;0xc	1100
	movwf	sa
	movwf	sb
	return
	call	fill1s	;0xd	1101   fill with 1,s
	movlw	0x30
	movwf	sc
	return
	call	fill1s	;0xe	1110   fill with 1,s
	movlw	0x30
	movwf	sd
	return
	goto	fill1s	;0xf	1111   fill with 1,s
	return
;------------------------------------------------------------
main    bsf     status,rp0  ;switch to bank 1
	movlw	b'00000000' ;outputs
        movwf   trisa
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	movlw	b'00000000' ;all outputs low
	movwf	porta
	movwf	portb
	call	del_5	;allow lcd time to initialize itself
	call	initlcd	;initialize display
	movlw   0x01   ;load w with 0x__, test byte
	call	disphex	;call display hex byte sub
;			   returns with display RAM filled
	call	disp16	;send 16 characters to display
circle  goto    circle  ;done
;------------------------------------------------------------
fill1s	movlw	0x31
	movwf	sa
	movwf	sb
	movwf	sc
	movwf	sd
	return
;------------------------------------------------------------
disphex	movwf	hexbyte	;store copy of hex byte
	call	blanks	;fill display RAM with blanks
	call	sephex	;separate hex byte into 2 ASCII digits
	movf	ms_dig,w   ;get MS digit
	movwf	0x20	;to display RAM
	movf	ls_dig,w   ;get LS digit
	movwf	0x21	;to display RAM
	swapf	hexbyte,w  ;get copy of hex byte, swap MS/LS
	andlw	0x0f	;mask HI nybble
	call	hexbits	;call hex to bits
	movf	sa,w	;get first bit
	movwf	0x23	;to display RAM
	movf	sb,w	;get second bit
	movwf	0x24	;to display RAM
	movf	sc,w	;etc.
	movwf	0x25
	movf	sd,w
	movwf	0x26
	movf	hexbyte,w  ;get copy of hex byte
	andlw	0x0f	;mask HI nybble
	call	hexbits	;call hex to bits
	movf	sa,w	;get first bit
	movwf	0x28	;to display RAM
	movf	sb,w	;get second bit
	movwf	0x29	;to display RAM
	movf	sc,w	;etc.
	movwf	0x2a
	movf	sd,w
	movwf	0x2b
	return
;------------------------------------------------------------
sephex	movf	hexbyte,w   ;get copy of hex byte
	andlw	0x0f	;mask hi nybble
	call	hex2asc	;hex to ASCII conversion
	movwf	ls_dig	;store
	swapf	hexbyte,w   ;get copy of hex byte, swap MS/LS
	andlw	0x0f	;mask hi nybble
	call	hex2asc	;hex to ASCII conversion
	movwf	ms_dig	;store
	return
;------------------------------------------------------------
hex2asc	movwf	hold	;store copy of hex digit
	sublw	0x09	;subtract w from 1 less than 0x0a
	btfss	status,c   ;carry flag set if w < 0x0a
	goto	add37
	goto	add30
add37	movf	hold,w	;get hex digit
	addlw	0x37
	return		;return with ascii in w
add30	movf	hold,w	;get hex digit
	addlw	0x30
	return		;return with ascii in w
;------------------------------------------------------------
hexbits	movwf	hold	;save copy of hex digit
	movlw	0x30	;fill with ascii 0's
	movwf	sa
	movwf	sb
	movwf	sc
	movwf	sd
	movf	hold,w	;get hex digit, use as offset
	call	table	;get 2nd offset for subroutine table
	call	makbits	;to appropriate create bits sub
	return
;------------------------------------------------------------
blanks	movlw	0x10	;count=16
	movwf	count1
	movlw	0x20	;first display RAM address
	movwf	fsr	;indexed addressing
	movlw	0x20	;ascii blank
store	movwf	indf	;store in display RAM location
;			   pointed to by file select register
	decfsz	count1,f  ;16?
	goto	incfsr	;no
	return		;yes, done
incfsr	incf	fsr,f	;increment file select register
	goto	store
;------------------------------------------------------------
initlcd bcf	porta,1	;E line low
	bcf	porta,2	;RS line low, set up for control
	call	del_125	;delay 125 microseconds
	movlw	0x38	;8-bit, 5X7
	movwf	portb	;0011 1000
	call	pulse	;pulse and delay
	movlw	0x0c	;display on, cursor off
	movwf	portb	;0000 1100
	call	pulse
	movlw	0x06	;increment mode, no display shift
	movwf	portb	;0000 0110
	call	pulse
	call	del_5   ;delay 5 milliseconds - required
;			   before sending data
	return
;------------------------------------------------------------
disp16	bcf	porta,1	;E line low
	bcf	porta,2	;RS line low, set up for control
	call	del_125	;delay 125 microseconds
	movlw	0x80	;control word = address first half
	movwf	portb
	call	pulse	;pulse and delay
	bsf	porta,2	;RS=1, set up for data
	call	del_125	;delay 125 microseconds
	movlw	0x20	;initialze file select register
	movwf	fsr
getchar	movf	0x00,w	;get character from display RAM
;			   location pointed to by file select
;			   register
	movwf	portb
	call	pulse	;send data to display	
	movlw	0x27	;8th character sent?
	subwf	fsr,w	;subtract w from fsr
	btfsc	status,z   ;test z flag
	goto	half	;set up for last 8 characters
	movlw	2f	;test number
	subwf	fsr,w
	btfsc	status,z   ;test z flag
	return		;16 characters sent to lcd
	incf	fsr,f	;move to next character location
	goto	getchar
half	bcf	porta,2	;RS=0, set up for control
	call	del_125	;delay 125 microseconds
	movlw	0xc0	;control word = address second half
	movwf	portb
	call	pulse	;pulse and delay
	bsf	porta,2	;RS=1, set up for data
	incf	fsr,f	;increment file select register to
;			   select next character
	call	del_125	;delay 125 microseconds
	goto	getchar
;------------------------------------------------------------
del_125	movlw	0x2a	;approx 42x3 cycles (decimal)
	movwf	count1	;load counter
repeat	decfsz	count1,f   ;decrement counter
	goto	repeat	;not 0
	return		;counter 0, ends delay	
;------------------------------------------------------------
del_5	movlw	0x29	;decimal 40
	movwf	count2	;to counter
delay	call	del_125	;delay 125 microseconds
	decfsz	count2,f   ;do it 40 times = 5 milliseconds
	goto	delay
	return		;counter 0, ends delay
;------------------------------------------------------------
pulse	bsf	porta,1	;pulse E line
	nop		;delay
	bcf	porta,1
	call	del_125	;delay 125 microseconds
	return
;------------------------------------------------------------
       end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test)
;       power-up timer on
;============================================================

